! fs2uc12.f: demonstration / use case 12 for S2PLOT library.
!
! David Barnes, October 2006
!
! $Id: fs2uc12.f90,v 1.2 2006/12/22 03:33:25 dbarnes Exp $
!
! Demonstrate use of s2latexture to simply generate a texture with
! LaTeX output on it for use in geometry.
!
!     Some useful variables
      integer i
      integer texnum
      real aspect
      real*8 PF4(3,4)
      real*8 COLOUR(3)
!
      integer s2opend
      integer s2latexture
!
!     open S2PLOT device
      i = s2opend('/?')
      if (i.eq.0) then
        write(*,*) 'Failed to open S2PLOT device - exiting.'
        call exit()
      endif
      call s2svp(-0.7, 0.7, -0.7, 0.7, -0.7, 0.7)
      call s2swin(-1., 1., -1., 1., -1., 1.)
!
!     create a texture from LaTeX syntax
      texnum = s2latexture('$x^2 + y^2$', aspect)
!
!     draw a 4-vertex facet with this texture on it
      PF4(1,1) = -0.3 * aspect
      PF4(2,1) =  0.3
      PF4(3,1) =  0.0
!      
      PF4(1,2) =  0.3 * aspect
      PF4(2,2) =  0.3
      PF4(3,2) =  0.0
!
      PF4(1,3) =  0.3 * aspect
      PF4(2,3) = -0.3
      PF4(3,3) =  0.0
!
      PF4(1,4) = -0.3 * aspect
      PF4(2,4) = -0.3
      PF4(3,4) =  0.0
!
      COLOUR(1) = 0.1
      COLOUR(2) = 0.6
      COLOUR(3) = 0.1
!
      call s2vf4tid(PF4, COLOUR, texnum, 1., 'o')
!
!     draw a red box 
      call s2sci(2)
      call s2sch(1.2)
      call s2slw(1)
      call s2box('BCDETS', 0., 0, 'BCDETS', 0., 0, 'BCDETS', 0., 0)
!
!     Go into S2PLOT interactive mode
      call s2show(1)
!     
      end
