! fs2uc6extern.f90: external functions used by fs2uc6.f90 program
!
! David Barnes, February 2006
!
! $Id: fs2uc6extern.f90,v 3.1 2007/04/04 22:56:39 dbarnes Exp $
!
      SUBROUTINE NEWCALLBACK(T, IC)
      REAL*8 T
      INTEGER IC
      INCLUDE 'fs2uc6b.inc'
      REAL PHASE
      REAL X1, X2, Y1, Y2, Z1, Z2
      REAL X(100), Y(100), Z(100)
      INTEGER INITIALISED,I,J
      CHARACTER BUFFER*60
      real etime                ! Declare the type of etime()
      real elapsed(2)           ! For receiving user and system time
      real start,finsh          ! For receiving total time
      INCLUDE 'fs2uc6.inc'
      SAVE X,Y,Z,INITIALISED,PHASE
!
!     create a population of points or jitter the existing points
!     
!
!     determine the world bounds
      call s2qwin(X1,X2,Y1,Y2,Z1,Z2)
!     
!     create randomly jittering dots
      IF (INITIALISED.EQ.0) THEN
         DO 20 I=1,100
            X(I) = X1 + RAND(0) * (X2 - X1)
            Y(I) = Y1 + RAND(0) * (Y2 - Y1)
            Z(I) = Z1 + RAND(0) * (Z2 - Z1)
 20      CONTINUE
         INITIALISED=1
      ELSE
         DO 30 I=1,100
            X(I) = X(I) + (RAND(0) - 0.5) * (X2 - X1) / 133.
            Y(I) = Y(I) + (RAND(0) - 0.5) * (Y2 - Y1) / 133.
            Z(I) = Z(I) + (RAND(0) - 0.5) * (Z2 - Z1) / 133.
 30      CONTINUE
      ENDIF
!     
!     draw the dots
      call s2sci(1)
      call s2slw(1.)
      call s2pt(100, X, Y, Z, 1)
!
!     draw the ball following a lissajous-like figure in 3d space
!     phase is between 0 and 10 seconds
!      ITMP = T / 10.
!      PHASE = T - 1. * ITMP * 10.     
!     new version: step per call rather than per time interval
      phase = phase + 0.05
      call s2sci(5)
!     We need to store the following results to make them REAL iso REAL*8
!     (although changing PHASE to REAL iso REAL*8 might have fixed this)
      X1 = (X1+X2)*0.5 + (X2-X1)*0.5*COS(PHASE/10.*TWOPI)
      Y1 = (Y1+Y2)*0.5 + (Y2-Y1)*0.5*SIN(PHASE/3.3333*TWOPI)
      Z1 = (Z1+Z2)*0.5
      call s2pt1(X1, Y1, Z1, 4)
!
!      call cs2dcb()
      if (NUMBER.GE.0) then
         write(buffer, '(A,I1)') '\nlast key press = ', number
         call s2iden(buffer)
! behaviour depends on what number we pressed...
         if (NUMBER.GT.0) then
!     sleep for (number - 1) tenths of a second
            start = etime(elapsed)
            finsh = etime(elapsed)
            do while ((finsh-start)*10.lt.(number-1))
               j = 0
               do i=1,1000
                  j = j + 1
               enddo
               finsh = etime(elapsed)
            enddo
         else
!     this beautiful thing is now possible: switch the callback off!
!     The only way to turn it back on is for the user to hit the animation
!     key "z"...
            call cs2dcb()
         endif
      endif
!
!     you could even change the callback to another function if you want, eg.
!     call cs2scb(ANOTHERFN)
!
      RETURN
      END
!
!
!
!
      SUBROUTINE NUMCB(NUM)
      INCLUDE 'fs2uc6b.inc'
      NUMBER = NUM
      RETURN
      END
!
